import type { IBuilderObj, IModelEntity, IPaginated, IQueryFields, QueryBuilder, PrismaValidStringFilter, PrismaWhereInput } from '../types';
declare class ApiQueryBuilder<TModelEntity extends IModelEntity = IModelEntity, WhereInput = PrismaWhereInput, PrismaModelDelegate extends any = any> {
    protected query: IQueryFields;
    protected modelEntity: PrismaModelDelegate;
    protected entity: IModelEntity;
    protected validStringFilter: PrismaValidStringFilter[];
    protected builder: QueryBuilder;
    protected builderObj: IBuilderObj;
    constructor(modelEntity: PrismaModelDelegate, entity: TModelEntity, query?: IQueryFields, validStringFilter?: PrismaValidStringFilter[]);
    filter(): this;
    sort(): this;
    select(): this;
    populate(): this;
    paginate(): this;
    build(): this;
    all(): this;
    many(): Promise<"NotFoundException" | {
        data: Partial<TModelEntity>[];
        paginated: IPaginated;
    }>;
    findMany(filter: WhereInput): Promise<"NotFoundException" | "Invalid Filter Parameter" | {
        data: Partial<TModelEntity>[];
        paginated: IPaginated;
    }>;
    one(filter: WhereInput): Promise<Partial<TModelEntity> | "Invalid Filter Parameter">;
    private toArray;
    private arrayToBoolObject;
    private filterRecursive;
}
export default ApiQueryBuilder;
